theory Demo03
  imports Main
begin

text \<open>
An iterative reverse function that is linear in the first argument.
\<close>
fun itrev :: "'a list \<Rightarrow> 'a list \<Rightarrow> 'a list"
  where
    "itrev [] acc = acc"
  | "itrev (x # xs) acc = itrev xs (x # acc)"

text \<open>
When the accumulator is initialized to the empty list, then
@{const itrev} behaves like @{const rev}.
\<close>
lemma itrev_rev_conv: "itrev xs [] = rev xs"
  sorry

end
